// tB^ݒ GNX|[gvOC
#include <windows.h>
#include <stdio.h>
#include "filter.h"

FILTER_DLL filter = {
  FILTER_FLAG_EXPORT|FILTER_FLAG_NO_CONFIG|FILTER_FLAG_ALWAYS_ACTIVE|FILTER_FLAG_PRIORITY_LOWEST|FILTER_FLAG_EX_INFORMATION,
  0,0,
  "tB^ݒ",
  NULL,NULL,NULL,
  NULL,NULL,
  NULL,NULL,NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  func_WndProc,
  NULL,NULL,
  NULL,
  NULL,
  "tB^ݒ GNX|[g ver.1.1 by Aji",
  NULL,
  NULL,
};

EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable(void)
{
  return &filter;
}

BOOL set_clipboard_text(HWND hwnd, char *str)
{
  HANDLE hMem;
  char *mem;
  int l = 0;
  
  while(str[l++]) ;
  if((hMem = GlobalAlloc(GMEM_SHARE|GMEM_MOVEABLE, l)) == NULL) return FALSE;
  
  if((mem = (char*)GlobalLock(hMem)) == NULL){
    GlobalFree(hMem);
    return FALSE;
  };
  memcpy(mem, str, l);
  GlobalUnlock(hMem);
  
  if(!OpenClipboard(hwnd)){
    GlobalFree(hMem);
    return FALSE;
  }
  EmptyClipboard();
  SetClipboardData(CF_TEXT, hMem);
  CloseClipboard();
  
  return TRUE;
}

static char* name_from_path(char* path)
{
  int b, p, i;
  
  b = p = -1;
  for(i = 0; i < 1023 && path[i] != 0 ; i++){
    if(path[i] == '\\') b = i;
    if(path[i] == '.') p = i;
  }
  
  path[(p > b + 1 && p < i - 1 && p >= i - 5) ? p : i] = 0;
  return path + b + 1;
}

BOOL func_WndProc(HWND, UINT message, WPARAM, LPARAM, void *editp, FILTER *fp)
{
  char buf[4096], name[1024], *ptr;
  SYS_INFO sip;
  FILTER *filp;
  int c, i, j;
  
  if(!fp->exfunc->is_editing(editp)) return FALSE;
  
  if(message == WM_FILTER_EXPORT){
    if(!fp->exfunc->get_sys_info(editp, &sip)) return FALSE;
    ptr = buf;
    for(i = 0; i < sip.filter_n; i++){
      if((filp = (FILTER*)fp->exfunc->get_filterp(i)) == NULL) continue;
      if(strcmp(filp->name, "t[[g̐ݒ") == 0) continue;
      if(strcmp(filp->name, "tB[hI[_[") == 0) continue;
      if(!fp->exfunc->is_filter_active(filp)) continue;
      if(filp->track_n <= 0 && filp->check_n <= 0) continue;
      if(filp->flag & (FILTER_FLAG_CONFIG_POPUP|FILTER_FLAG_DISP_FILTER|FILTER_FLAG_NO_CONFIG|FILTER_FLAG_AUDIO_FILTER|FILTER_FLAG_INTERLACE_FILTER|FILTER_FLAG_IMPORT|FILTER_FLAG_EXPORT)) continue;
      GetModuleFileName(filp->dll_hinst, name, 1024);
      c = '(';
      ptr += wsprintf(ptr, "AU_%s", name_from_path(name));
      for(j = 0; j < filp->track_n; j++){
        ptr += wsprintf(ptr, "%c%d", c, filp->track[j]);
        c = ',';
      }
      for(j = 0; j < filp->check_n; j++){
        ptr += wsprintf(ptr, "%c%s", c, filp->check[j] ? "true" : "false");
        c = ',';
      }
      ptr += wsprintf(ptr, ") #%s\n", filp->name);
    }
    
    set_clipboard_text(fp->hwnd, buf);
  }
  
  return FALSE;
}
